setwd("D:/Dropbox/Work/diskretni volby - pracovní")
library("mlogit")
d=read.table("data_privat3.dat",header = T)
d=d[d$ok==1,]
d$zariz_1=as.factor(d$zariz_1)
d$zariz_2=as.factor(d$zariz_2)
d$zariz_3=as.factor(d$zariz_3)
d$zariz_4=as.factor(d$zariz_4)
d$posob_1=as.factor(d$posob_1)
d$posob_2=as.factor(d$posob_2)
d$posob_3=as.factor(d$posob_3)
d$posob_4=as.factor(d$posob_4)
md=mlogit.data(d,"Choice",shape="wide",varying=7:22,sep="_",id.var = "id")

#####    obycejny logit    ##########
m1=mlogit(Choice ~ najem + posob + vzdal + zariz + 0, md)
summary(m1)
LL0 = log(1/4)*nrow(d)
cat("R2(m1) = ",1-as.numeric(m1$logLik)/LL0,"\n")
cat("AIC(m1)= ",2*length(m1$coefficients)-as.numeric(m1$logLik),"\n")
vcov(m1,"coefficient",type=c("cov"))  # kovariance parametru

####    mixed logit  ##########
m2=mlogit(Choice ~ najem + posob + vzdal + zariz + 0, md, panel = T,rpar=c(najem="n",posob3="n",posob2="n"), R=1000,
          start = c(c(m1$coefficients),0.0,0.0,0.0))
summary(m2)
cat("R2(m2) = ",1-LL2/LL0,"\n")
cat("AIC(m2)= ",2*length(m2$coefficients)-as.numeric(m2$logLik),"\n")
vcov(m2,"coefficient",type=c("cov"))  # kovariance parametru











####    mixed logit 2   ##########
md2=md
md2$zariz=as.numeric(md2$zariz)
md2$zariz[md2$zariz>1]=md2$zariz[md2$zariz>1]-1
md2$zariz=md2$zariz-1
m3=mlogit(Choice ~ najem + posob + vzdal + zariz + 0, md2, panel = T,rpar=c(najem="n",posob2="n"),correlation = F, R=1000,
          start = c(c(m1$coefficients[-5]),0,0),fixed=T)
summary(m3)
LL3=as.numeric(m3$logLik)
cat("R2(m3)=",1-LL3/LL0,"\n")
cat("AIC(m3)=",2*length(m3$coefficients)-LL3,"\n")

####    mixed logit 2   ##########
md2=md
md2$zariz=as.numeric(md2$zariz)
md2$zariz[md2$zariz>1]=md2$zariz[md2$zariz>1]-1
md2$zariz=md2$zariz-1
m3=mlogit(Choice ~ najem + posob + vzdal*gen + zariz + 0 , md,correlation = F, R=1000)
summary(m3)
LL3=as.numeric(m3$logLik)
cat("R2(m3)=",1-LL3/LL0,"\n")
cat("AIC(m3)=",2*length(m3$coefficients)-LL3,"\n")

